/* See license.txt for terms of usage */

var AQwikWiki_Buttons = {};

AQwikWiki_Buttons.createWikipedia = function( doc, clickHandler ) {
	var radius = 7;
	var inColor = "#999999";
	var inColorOver = "#bbbbbb";
	var strokeWidth = 2;
	var strokeColor = "#444444";
	var svgElem = doc.createElementNS("http://www.w3.org/2000/svg",'svg');
	var circle = doc.createElementNS("http://www.w3.org/2000/svg",'circle');
	var iCircle = doc.createElementNS("http://www.w3.org/2000/svg",'circle');
	svgElem.style.width = ((radius+2)*2+1) + "px";
	svgElem.style.height = ((radius+2)*2+1) + "px";
	svgElem.style.verticalAlign = "middle"; 
	circle.setAttributeNS( null, 'r', radius );
	circle.setAttributeNS( null, 'cx', radius+3 );
	circle.setAttributeNS( null, 'cy', radius+3 );
	circle.setAttributeNS( null, 'fill', inColor);	
	circle.setAttributeNS( null, 'stroke', strokeColor );
	circle.setAttributeNS( null, 'stroke-width', strokeWidth );				
	svgElem.appendChild( circle );
	var l1 = doc.createElementNS("http://www.w3.org/2000/svg",'line');
	var l2 = doc.createElementNS("http://www.w3.org/2000/svg",'line');
	var l3 = doc.createElementNS("http://www.w3.org/2000/svg",'line');
	var l4 = doc.createElementNS("http://www.w3.org/2000/svg",'line');
	
	l1.setAttributeNS(null,'stroke','#151015');
	l1.setAttributeNS(null,'stroke-width','2');
	l1.setAttributeNS(null,'stroke-linecap','round');
	l1.setAttributeNS(null,'x1','14');
	l1.setAttributeNS(null,'y1','7');
	l1.setAttributeNS(null,'x2','12');
	l1.setAttributeNS(null,'y2','14');
	l2.setAttributeNS(null,'stroke','#151015');
	l2.setAttributeNS(null,'stroke-width','2');
	l2.setAttributeNS(null,'stroke-linecap','round');
	l2.setAttributeNS(null,'x1','6');
	l2.setAttributeNS(null,'y1','7');
	l2.setAttributeNS(null,'x2','8');
	l2.setAttributeNS(null,'y2','14');
	l3.setAttributeNS(null,'stroke','#151015');
	l3.setAttributeNS(null,'stroke-width','2');
	l3.setAttributeNS(null,'stroke-linecap','round');
	l3.setAttributeNS(null,'x1','10');
	l3.setAttributeNS(null,'y1','9');
	l3.setAttributeNS(null,'x2','12');
	l3.setAttributeNS(null,'y2','14');
	l4.setAttributeNS(null,'stroke','#151015');
	l4.setAttributeNS(null,'stroke-width','2');
	l4.setAttributeNS(null,'stroke-linecap','round');
	l4.setAttributeNS(null,'x1','10');
	l4.setAttributeNS(null,'y1','9');
	l4.setAttributeNS(null,'x2','8');
	l4.setAttributeNS(null,'y2','14');

	svgElem.appendChild(l1);
	svgElem.appendChild(l2);
	svgElem.appendChild(l3);
	svgElem.appendChild(l4);
	svgElem.addEventListener('click', function( event ) {
		clickHandler( event );
	},false);
	svgElem.addEventListener('mouseover', function( event ) {
		circle.setAttributeNS( null, 'fill', inColorOver);	
	},false);
	svgElem.addEventListener('mouseout', function( event ) {
		circle.setAttributeNS( null, 'fill', inColor);	
	},false);
	return svgElem;
}

AQwikWiki_Buttons.createExpand = function( doc, clickHandler ) {
	var radius = 7;
	var inColor = "#999999";
	var inColorOver = "#bbbbbb";
	var strokeWidth = 2;
	var strokeColor = "#444444";
	var svgElem = doc.createElementNS("http://www.w3.org/2000/svg",'svg');
	var circle = doc.createElementNS("http://www.w3.org/2000/svg",'circle');
	var iCircle = doc.createElementNS("http://www.w3.org/2000/svg",'circle');
	svgElem.style.width = ((radius+2)*2+1) + "px";
	svgElem.style.height = ((radius+2)*2+1) + "px";
	svgElem.style.verticalAlign = "middle"; 
	circle.setAttributeNS( null, 'r', radius );
	circle.setAttributeNS( null, 'cx', radius+3 );
	circle.setAttributeNS( null, 'cy', radius+3 );
	circle.setAttributeNS( null, 'fill', inColor);	
	circle.setAttributeNS( null, 'stroke', strokeColor );
	circle.setAttributeNS( null, 'stroke-width', strokeWidth );				
	svgElem.appendChild( circle );
	var l1 = doc.createElementNS("http://www.w3.org/2000/svg",'line');
	var l2 = doc.createElementNS("http://www.w3.org/2000/svg",'line');
	l1.setAttributeNS(null,'stroke','#151015');
	l1.setAttributeNS(null,'stroke-width','3');
	l1.setAttributeNS(null,'stroke-linecap','round');
	l1.setAttributeNS(null,'x1','8');
	l1.setAttributeNS(null,'y1','13');
	l1.setAttributeNS(null,'x2','13');
	l1.setAttributeNS(null,'y2','10');
	l2.setAttributeNS(null,'stroke','#151015');
	l2.setAttributeNS(null,'stroke-width','3');
	l2.setAttributeNS(null,'stroke-linecap','round');
	l2.setAttributeNS(null,'x1','8');
	l2.setAttributeNS(null,'y1','7');
	l2.setAttributeNS(null,'x2','13');
	l2.setAttributeNS(null,'y2','10');				
	svgElem.appendChild(l1);
	svgElem.appendChild(l2);
	svgElem.addEventListener('click', function( event ) {
		clickHandler( event );
	},false);
	svgElem.addEventListener('mouseover', function( event ) {
		circle.setAttributeNS( null, 'fill', inColorOver);	
	},false);
	svgElem.addEventListener('mouseout', function( event ) {
		circle.setAttributeNS( null, 'fill', inColor);	
	},false);
	return svgElem;
}


AQwikWiki_Buttons.createCollapse = function( doc, clickHandler ) {
	var radius = 7;
	var inColor = "#999999";
	var inColorOver = "#bbbbbb";
	var strokeWidth = 2;
	var strokeColor = "#444444";
	var svgElem = doc.createElementNS("http://www.w3.org/2000/svg",'svg');
	var circle = doc.createElementNS("http://www.w3.org/2000/svg",'circle');
	var iCircle = doc.createElementNS("http://www.w3.org/2000/svg",'circle');
	svgElem.style.width = ((radius+2)*2+1) + "px";
	svgElem.style.height = ((radius+2)*2+1) + "px";
	svgElem.style.verticalAlign = "middle"; 
	circle.setAttributeNS( null, 'r', radius );
	circle.setAttributeNS( null, 'cx', radius+3 );
	circle.setAttributeNS( null, 'cy', radius+3 );
	circle.setAttributeNS( null, 'fill', inColor);	
	circle.setAttributeNS( null, 'stroke', strokeColor );
	circle.setAttributeNS( null, 'stroke-width', strokeWidth );				
	svgElem.appendChild( circle );
	var l1 = doc.createElementNS("http://www.w3.org/2000/svg",'line');
	l1.setAttributeNS(null,'stroke','#151015');
	l1.setAttributeNS(null,'stroke-width','3');
	l1.setAttributeNS(null,'stroke-linecap','round');
	l1.setAttributeNS(null,'x1','12');
	l1.setAttributeNS(null,'y1','13');
	l1.setAttributeNS(null,'x2','7');
	l1.setAttributeNS(null,'y2','10');				
	var l2 = doc.createElementNS("http://www.w3.org/2000/svg",'line');
	l2.setAttributeNS(null,'stroke','#151015');
	l2.setAttributeNS(null,'stroke-width','3');
	l2.setAttributeNS(null,'stroke-linecap','round');
	l2.setAttributeNS(null,'x1','12');
	l2.setAttributeNS(null,'y1','7');
	l2.setAttributeNS(null,'x2','7');
	l2.setAttributeNS(null,'y2','10');				
	svgElem.appendChild(l1);
	svgElem.appendChild(l2);
	svgElem.addEventListener('click', function( event ) {
		clickHandler( event );
	},false);
	svgElem.addEventListener('mouseover', function( event ) {
		circle.setAttributeNS( null, 'fill', inColorOver);	
	},false);
	svgElem.addEventListener('mouseout', function( event ) {
		circle.setAttributeNS( null, 'fill', inColor);	
	},false);
	return svgElem;
}


