/* See license.txt for terms of usage */

var AQwikWiki_Utilities = {};


AQwikWiki_Utilities.isTextSelected = function() {
	var focusedWindow = document.commandDispatcher.focusedWindow;
	var doc = window._content.document;
	
	if ( focusedWindow && 
			doc &&
			doc.body &&
			focusedWindow.getSelection() &&
			focusedWindow.getSelection().rangeCount>0 &&
			focusedWindow.getSelection().getRangeAt(0) &&
				(
						focusedWindow.getSelection().isCollapsed==false
						||
						focusedWindow.getSelection().getRangeAt(0).startOffset!=focusedWindow.getSelection().getRangeAt(0).endOffset
				) &&
			focusedWindow.getSelection().getRangeAt(0).startContainer
			) {
		return true;
	}
	
	return false;
}

AQwikWiki_Utilities.getWords= function( language, text ) {
	
	var allWords = text.split(/\s+/);
	var words = []
	for ( idx in allWords ) {
		var currWord = allWords[idx];
		currWord = currWord.replace(/\s+/g,"");
		
		//
		// English support
		if ( language=="en" ) {
			currWord = currWord.replace(/[^a-zA-Z0-9]/g,"");
		}
		
		//
		// French support
		if ( language=="fr" ) {
			currWord = currWord.replace(/[^a-zA-Z0-9وϝ؂]/g,"x");
		}

		//
		// German support
		if ( language=="de" ) {
			currWord = currWord.replace(/[^a-zA-Z0-9]/g,"");
		}
		
		if ( currWord.length>0 ) {
			words[ words.length ] = currWord;
		}
	}
	
	return words;
}

AQwikWiki_Utilities.reportException = function( exp ) {
	alert( "[AQwikWiki exception] " + exp + "\n" + exp.stack );
}
