/* See license.txt for terms of usage */

var AQwikWiki_GLOBAL_INDEX = 0;

function AQwikWiki() {
	
	this.uniqueID = AQwikWiki_GLOBAL_INDEX++;
	
	//
	// Load user's perferences
	//
	// Read user preferences
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	prefs = prefs.getBranch("extensions.aqwikwiki.");
	AQwikWiki_Preferences_isHTML = prefs.getBoolPref("isHTML");
	AQwikWiki_Preferences_isBOLD = prefs.getBoolPref("isBOLD");
	AQwikWiki_Preferences_c1 = prefs.getCharPref("interleavingState");
	AQwikWiki_Preferences_c2 = prefs.getCharPref("interleavingState2");
	AQwikWiki_Preferences_bg1 = prefs.getCharPref("interleavingStateBG");
	AQwikWiki_Preferences_bg2 = prefs.getCharPref("interleavingStateBG2");
	AQwikWiki_Preferences_src = prefs.getCharPref("source");
	
	//
	// Grab current window
	var focusedWindow = document.commandDispatcher.focusedWindow;
	var doc = window._content.document;
	
	//
	// Determine whether text was selected
	if ( AQwikWiki_Utilities.isTextSelected() ) {
				
		try {
			
			//
			// Get selected text
			var range  = focusedWindow.getSelection().getRangeAt(0);
			var selectedText = range.toString();
			var terms = AQwikWiki_Utilities.getWords( AQwikWiki_Preferences_src, selectedText );			
			
			//
			// Determine whether the selected range is within a wikiAnswer
			var interleavingState = 0;
			node = range.startContainer;
			while (node!=null ) {
			    if ( node.id && (node.id == "AQwikWiki_answer0" || node.id == "AQwikWiki_answer1") ) {
			    	if ( node.id=="AQwikWiki_answer0" ) {
			    		interleavingState = 1;
			    	}
			    	break;
			    }
			    node = node.parentNode;
			}
			
			//
			// Output preliminary message
			doc = content.document;
			
			var wikiAnswer = content.document.createElement('span');
			
			
			var wikiLoading = content.document.createElement('span');
			wikiLoading.innerHTML = "&nbsp;<b>AQwikWiki: Loading results</b>";
			var wikiLoadingD1 = content.document.createElement('span');
			wikiLoadingD1.innerHTML = ".";
			var wikiLoadingD2 = content.document.createElement('span');
			wikiLoadingD2.innerHTML = ".";
			var wikiLoadingD3 = content.document.createElement('span');
			wikiLoadingD3.innerHTML = ".";
			wikiAnswer.appendChild( wikiLoading );
			wikiAnswer.appendChild( wikiLoadingD1 );
			wikiAnswer.appendChild( wikiLoadingD2 );
			wikiAnswer.appendChild( wikiLoadingD3 );
			var wikiLoadingState=2;
			var wikiRotateLoad = function() {		
				wikiLoadingState++;
				wikiLoadingState = wikiLoadingState % 3;
				if ( wikiLoadingState>0 ) {
					wikiLoadingD2.style.color = wikiLoading.style.color;
				} else {
					var bgColor = AQwikWiki_Preferences_bg2;
					if ( interleavingState==0 ) {
						bgColor = AQwikWiki_Preferences_bg1;
					}
					wikiLoadingD2.style.color = bgColor;
					wikiLoadingD3.style.color = bgColor;
				}
				if ( wikiLoadingState>1 ) {
					wikiLoadingD3.style.color = wikiLoading.style.color;
				}
			}
			var loadIntervalID = window.setInterval( wikiRotateLoad, 400);
			
			if ( interleavingState==0 ) {
				wikiAnswer.style.color = AQwikWiki_Preferences_c1;
				wikiAnswer.style.background = AQwikWiki_Preferences_bg1;
			} else {
				wikiAnswer.style.color = AQwikWiki_Preferences_c2;
				wikiAnswer.style.background = AQwikWiki_Preferences_bg2;
			}
			wikiAnswer.id = "AQwikWiki_answer" + interleavingState;
			range.collapse(false);
			range.insertNode( wikiAnswer );
			
			
			//
			// Set up the result handler
			var resultHandler = function( resultType, firstParagraph, url ) {	
				
				//
				// Dismiss load animation
				window.clearInterval( loadIntervalID );
				
				var textElem = doc.createElement('span');							
				var controlElem = doc.createElement('span');
				
				//
				// In case of no results
				if ( resultType==0 ) {
					textElem.innerHTML = " No Result ";	
					
					//
					// Button
					var collapseButton = AQwikWiki_Buttons.createCollapse( doc, function(event) {
							var parent = wikiAnswer.parentNode;
							parent.removeChild( wikiAnswer );
						} 
					);
					controlElem.appendChild( collapseButton );				
					
					//
					// Update wiki element
					wikiAnswer.innerHTML = "";				
					wikiAnswer.appendChild( textElem );
					wikiAnswer.appendChild( controlElem );					
				}
				
				//
				// In case of regular result
				if ( resultType==1) {
					
					//
					// expansionState: 1 - single, 2-paragraph, 3-new tab 0-close
					var expansionState = 1;
					
					//textElem.innerHTML = firstParagraph;
					var sentences = firstParagraph.split(/\.[^a-zA-Z]*\s+/);
					var firstSentence = sentences[0] + ".";
					textElem.innerHTML = firstSentence;
					
					//
					// Button
					var wikipediaButton = AQwikWiki_Buttons.createWikipedia( doc, function(event) {
							expansionState++;
							
							if ( expansionState>2 ) {
								gBrowser.addTab(url);
								expansionState=2;
							}
						} 
					);
					var expandButton = AQwikWiki_Buttons.createExpand( doc, function(event) {
							expansionState++;
							if ( expansionState==2 ) {
								textElem.innerHTML = firstParagraph;
								expandButton.style.display='none';
								wikipediaButton.style.display='';
							}
							
						} 
					);
					var collapseButton = AQwikWiki_Buttons.createCollapse( doc, function(event) {
							expansionState--;
							if ( expansionState==0 ) {
								var parent = wikiAnswer.parentNode;
								parent.removeChild( wikiAnswer );
							}
							if ( expansionState==1 ) {
								textElem.innerHTML = firstSentence;
								expandButton.style.display='';
								wikipediaButton.style.display='none';								
							}
						} 
					);
					wikipediaButton.style.display='none';
					controlElem.appendChild( collapseButton );				
					controlElem.appendChild( expandButton );
					controlElem.appendChild( wikipediaButton );
					
					
					//
					// Update wiki element
					wikiAnswer.innerHTML = "";				
					wikiAnswer.appendChild( textElem );
					wikiAnswer.appendChild( controlElem );
				}
				
				//
				// In case of Disambiguation
				if ( resultType==2 ) {
					textElem.innerHTML = " <a href=\'"+url+"\'>Disambiguation<a> ";	
					
					//
					// Button
					var collapseButton = AQwikWiki_Buttons.createCollapse( doc, function(event) {
							var parent = wikiAnswer.parentNode;
							parent.removeChild( wikiAnswer );
						} 
					);
					controlElem.appendChild( collapseButton );				
					
					//
					// Update wiki element
					wikiAnswer.innerHTML = "";				
					wikiAnswer.appendChild( textElem );
					wikiAnswer.appendChild( controlElem );
				}
				
			};
			
			//
			// Load content
			AQwikWiki_Wikipedia.load(AQwikWiki_Preferences_src, terms, resultHandler, AQwikWiki_Preferences_isHTML, AQwikWiki_Preferences_isBOLD);

			AQwikWiki_ContextMenu.turnMenuOff();
		} catch (exp) {
			AQwikWiki_Utilities.reportException( exp );
		}

		AQwikWiki_ContextMenu.turnMenuOn();
	}	
}
window.addEventListener("load", AQwikWiki_ContextMenu.init, false);